﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;


namespace DataShow
{
  public partial class GrafShow : Form
  {
    BinaryReader reader;
    Int16 [] data;
    double [] data_dbl;
    private Series s;
    private long num_elem;

    public GrafShow()
    {
      InitializeComponent();
    }

    private void btnOpenFile_Click(object sender, EventArgs e)
    {
      OpenFileDialog dlgopen = new OpenFileDialog();
      dlgopen.InitialDirectory = ".\\";
      dlgopen.Filter = "Все файлы|*.*";
      DialogResult result = dlgopen.ShowDialog();
      if (result == DialogResult.Cancel)
      {
        lblFileInName.Text = "Файл не выбран!";
        lblFileInName.ForeColor = Color.Red;
        btnOpenFile.Visible = true;
        return;
      }
      this.Refresh();
      lblFileInName.ForeColor = Color.Black;
      lblFileInName.Text = dlgopen.FileName;
      file_read(lblFileInName.Text);
      file_show(data);
    }

     private void file_read(string file_name)
     {
       try
       {
         reader = new BinaryReader(new FileStream(file_name, FileMode.Open, FileAccess.Read, FileShare.Read));
       }
       catch (FileNotFoundException e)
       {
         MessageBox.Show(e.Message.ToString(), "Ошибка!!!", System.Windows.Forms.MessageBoxButtons.OK,
                         System.Windows.Forms.MessageBoxIcon.Error);
         Environment.Exit(1);
       }
       long file_size = reader.BaseStream.Seek(0, SeekOrigin.End);
       num_elem = file_size / sizeof(Int16);
       reader.BaseStream.Seek(0, SeekOrigin.Begin);
       data = new short[num_elem];
       for (int i = 0; i < num_elem; i++)
       {
         data[i] = reader.ReadInt16();
       }
       reader.Close();
     }

     private void file_show(Int16[] data)
     {
       s = new Series("Sources");
       s.ChartType = SeriesChartType.Spline;
       s.Color = Color.Red;
       for (long i = 0; i < num_elem; i++)
       {
         s.Points.AddXY(i, data[i]); // Ошибка
       }
       chart1.Series.Add(s);
       chart1.Visible = true;
       chart1.Show();
       this.Refresh();
     }

    }
  }

